#include <stdio.h>
#include <avr/io.h>
#include <util/delay.h>
#include "eeprom.h"

int fputchar(char c, FILE *stream)
{
	(void)stream;
	if ( c == '\n' )
		fputchar('\r', stream);
	loop_until_bit_is_set(UCSRA, UDRE);
	UDR = c;

	return 0;
}

uint8_t buf[8] = {
	1, 2, 3, 4, 5, 6, 7,
};

FILE serial = FDEV_SETUP_STREAM(fputchar, NULL, _FDEV_SETUP_WRITE);

int main(void)
{
	stdout = &serial;
	UBRRH = 0;
	UBRRL = 197;
	DDRD = (1 << 1); // TXD
	DDRC = 2;        // debug
	UCSRB = (1 << TXEN);
	if (eeprom_write(0, buf, 30000)) printf("WRITE FAIL!\n\n");
	if (!eeprom_read(0, buf, 8)) {
		printf("%02X ", buf[0]);
		printf("%02X ", buf[1]);
		printf("%02X ", buf[2]);
		printf("%02X ", buf[3]);
		printf("%02X ", buf[4]);
		printf("%02X ", buf[5]);
		printf("%02X ", buf[6]);
		printf("%02X\n", buf[7]);
	}
	for(;;);
}
